// raunanje pi = 4*(1- 1/3 + 1/5 - 1/7 + ....)
// nitke, pravilno
// pri reitvi z loklano spremenljivko ne rabimo zaklepanja, nit lahko ob zakljuku
// vrne vrednost glavni niti
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#define N 1000000
#define NTHREADS 3

double pi;
int lock;

void *thread_sum(void *arg)
{
	int i, sign;
	int rank = (int)arg;
	int start = (int)(N/(double)NTHREADS*rank);
	int stop = (int)(N/(double)NTHREADS*(rank+1));

	double *mypi = (double*)malloc(sizeof(double));
	
	*mypi = 0.0;
	if( start%2 == 0)
		sign = 1;
	else 
		sign = -1;
	for(i=start; i<stop; i++, sign = -sign)
		*mypi += sign*4.0/(2*i+1);
	
	return (void *)mypi;
}

int main(void)
{
	int i;
	pthread_t t[NTHREADS];
	void *threadvalue;
	double threadpi;

	pi = 0.0;

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, thread_sum, (void *)i);

	for(i=0; i<NTHREADS; i++)
	{
		pthread_join(t[i], &threadvalue);
		threadpi = *((double *)threadvalue);
		pi += threadpi;
		free(threadvalue);
	}

	printf("pi = %lf\n", pi);

	return 0;
}
